#include <SoftwareSerial.h>

// konekcija --- motor kontroler pinovi na Arduino digitalne pinove

// motor jedan
int enR = 10;
int in1 = 9;

// motor dva
int enL = 5;
int in2 = 6;

//Distanca za zaustavljanje u cm
int Opasno = 15; 

//Bluetooth kontroler setup
SoftwareSerial Bluetooth(2, 3); // TX, RX
//int LED = 13; // LED na ploci
int Data; // podatci koji se primaju
int forward=1;
int left=3;
int reverse=5;
int right=7;
// Povecavanjem ili smanjivanjem broja (10) uskladjujemo brzine levog i desnog motora -- balans
int motorBalance = 10;
//inicijalna brzina motora 248 
int motorSpeedL = 248;
int motorSpeedR = motorSpeedL-motorBalance;
//senzor za daljinu
const int trigPin = 11;// --------------- Trig sa senzora na pin 11
const int echoPin = 12;// --------------- Echo sa senzora na pin 12
long duration;
int distance;

void setup() {
Serial.begin(9600); //initialize serial monitor
  Bluetooth.begin(9600); //initializacija blutut porta i komunikacija
 //Serial.println("Waiting for command..."); // serial monitor printout
  //Bluetooth.println("CD Robi"); // bluetooth client serial monitor printout
 // pinMode(LED,OUTPUT);
  pinMode(trigPin, OUTPUT);//--------------- senzor
  pinMode(echoPin, INPUT);//-------------- senzor

  // set all the motor control pins to outputs
  pinMode(enR, OUTPUT);
  pinMode(enL, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
}

void loop() 
{
       UDALJENOST ();
        
if (distance<=Opasno){
       STOP();
       motorAbackward();
        motorBbackward();
        // Bluetooth.println(distance); 
         delay(200);
          STOP();
     }
 
 if (Bluetooth.available()){ //prijem podataka
    Data=Bluetooth.read();
    //Serial.println(Data);
    if(Data<15){      
       if(Data==1){ //  -------    W za kretanje napred
                     
         NAPRED();      
    }
      else if(Data==3){ // ------ A za kretanje u levo
        motorAforward();
      }
      else if(Data==5){ // -------------- S za kretanje u nazad
        motorAbackward();
        motorBbackward();
      }
      else if(Data==7){ //  ------------  D za kretanje u desno
        motorBforward();
      }
      else if(Data==9){ // Rotacija Levo ---------------------
        motorAforward();
        motorBbackward();
      }
      else if(Data==11){ // Rotacija Desno -----------------------
        motorAbackward();
        motorBforward();
      }
       else if(Data==12){ // Daljina
        UDALJENOST();
        Bluetooth.println(distance);
      }
     else if(Data==2){ // when every button is released Android App sends a 2 == Stop
        STOP();
      }
     }  
    else if (Data<=255){
      motorSpeedL=Data;
      motorSpeedR=motorSpeedL-motorBalance;
      }
    }
  }

void NAPRED(){
 
  digitalWrite(in1, HIGH);
  analogWrite(enR, 255-motorSpeedR);
  digitalWrite(in2, LOW);
  analogWrite(enL, motorSpeedL);
       
}

void motorAforward(){
  digitalWrite(in1, HIGH);
  analogWrite(enR, 255-motorSpeedR);
}

void motorBforward(){
  digitalWrite(in2, LOW);
  analogWrite(enL, motorSpeedL);
}

void motorAbackward(){
  
  digitalWrite(in1, LOW);
  analogWrite(enR, motorSpeedR);
}

void motorBbackward(){
  digitalWrite(in2, HIGH);
  analogWrite(enL, 255-motorSpeedL);
}

void STOP(){
  digitalWrite(in2, LOW);
  analogWrite(enR, 0);
  digitalWrite(in1, LOW);
  analogWrite(enL, 0);
    
}
void UDALJENOST(){
digitalWrite(trigPin, LOW);
delayMicroseconds(2);
digitalWrite(trigPin, HIGH);
delayMicroseconds(10);
digitalWrite(trigPin, LOW);

duration = pulseIn(echoPin, HIGH);
distance= duration*0.034/2;

 //Serial.println(distance);
     
}
